/*
 *	Copyright (c) 2024 Scott Duensing, scott@kangaroopunch.com
 *
 *	Permission is hereby granted, free of charge, to any person obtaining a copy
 *	of this software and associated documentation files (the "Software"), to deal
 *	in the Software without restriction, including without limitation the rights
 *	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *	copies of the Software, and to permit persons to whom the Software is
 *	furnished to do so, subject to the following conditions:
 *
 *	The above copyright notice and this permission notice shall be included in
 *	all copies or substantial portions of the Software.
 *
 *	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *	SOFTWARE.
 */


#include "oc_math.h"
#include "variable.h"
#include "state.h"
#include "memory.h"


void opcodes_add(void) {
	variableStore(ZPEEK(__state.pc++), (int16_t)__state.operands[0] + (int16_t)__state.operands[1]);
}


void opcodes_and(void) {
	variableStore(ZPEEK(__state.pc++), __state.operands[0] & __state.operands[1]);
}


void opcodes_dec(void) {
	variableStore(__state.operands[0], variableLoad(__state.operands[0]) - 1);
}


void opcodes_div(void) {
	variableStore(ZPEEK(__state.pc++), (int16_t)__state.operands[0] / (int16_t)__state.operands[1]);
}


void opcodes_inc(void) {
	variableStore(__state.operands[0], variableLoad(__state.operands[0]) + 1);
}


void opcodes_mod(void) {
	variableStore(ZPEEK(__state.pc++), (int16_t)__state.operands[0] % (int16_t)__state.operands[1]);
}


void opcodes_mul(void) {
	variableStore(ZPEEK(__state.pc++), (int16_t)__state.operands[0] * (int16_t)__state.operands[1]);
}


void opcodes_not(void) {
	variableStore(ZPEEK(__state.pc++), ~__state.operands[0]);
}


void opcodes_or(void) {
	variableStore(ZPEEK(__state.pc++), __state.operands[0] | __state.operands[1]);
}


void opcodes_sub(void) {
	variableStore(ZPEEK(__state.pc++), (int16_t)__state.operands[0] - (int16_t)__state.operands[1]);
}
